# Lively Epsilon

Lively Epsilon is a plugin framework for [Empty Epsilon](https://daid.github.io/EmptyEpsilon/)(EE) that aims
to fill the space with artificial life.

If you are into writing missions this framework might help you create an intriguing universe full
of life that your crew will be eager to explore. You as a Game Master can focus on your plot lines
without needing to entertain all stations at all times.

Think about flying through the galaxy and watching traders ship goods from one station to another,
law-enforcement ships scanning ships, stations answering docking requests of NPCs or just two pilots
having a chat through comms. There is a lot to explore in that galaxy.

### State

The current state is best described as _Let's see where it goes_. Feel free to use it, steal everything
you find useful or drop me a line if you like it.

### Documentation

The documentation can be [read online](https://czenker.github.io/lively-epsilon/).

[![Guide](https://img.shields.io/badge/-Guide-green)](https://czenker.github.io/lively-epsilon/guide.html)
[![API Reference](https://img.shields.io/badge/-API_Reference-yellowgreen)](https://czenker.github.io/lively-epsilon/reference.html)
[![Specification](https://img.shields.io/badge/-Specification-grey)](https://czenker.github.io/lively-epsilon/spec.html)


### Development

[![Build Status](https://travis-ci.org/czenker/lively-epsilon.svg?branch=master)](https://travis-ci.org/czenker/lively-epsilon)
[![Test Coverage](https://codecov.io/github/czenker/lively-epsilon/branch/master/graphs/badge.svg)](https://codecov.io/gh/czenker/lively-epsilon)

If you want to contribute – and I hope you want to – see [CONTRIBUTING.md](CONTRIBUTING.md).

#### Tests

There are very few tests that test libraric functions, but they are by no means any proof that the modules
do what they should. Most of the code can not be tested outside an Empty Epsilon session.

You can run the tests by installing [Busted](https://olivinelabs.com/busted/) and run

```bash
busted
```
